/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 186 by dpavlin, Tue Mar 16 20:53:59 2010 UTC revision 218 by root, Mon Jun 14 12:13:14 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="-"
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52  }  }
53    
54    
# Line 53  cleanup_init_scripts() { Line 59  cleanup_init_scripts() {
59                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
60                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
61                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
62                    $rootfs/etc/rc?.d/*udev* \
63          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
64  }  }
65    
# Line 73  setup_inittab() { Line 80  setup_inittab() {
80  }  }
81    
82    
83    lxc_log() {
84            echo `date +%Y-%m-%dT%H:%M:%S` $*
85    }
86    
87    
88  lxc_kill() {  lxc_kill() {
89          name=$1          name=$1
90          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 94  lxc_kill() {
94                  lxc-info -n $name                  lxc-info -n $name
95                  exit 1                  exit 1
96          fi          fi
97          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
98          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
99  }  }
100    
101  lxc_stop() {  lxc_stop() {
102            lxc_log "$name stop"
103          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
104          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
105            lxc_log "$name stoped"
106  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
107  }  }
108    
# Line 97  lxc_start() { Line 111  lxc_start() {
111          name=$1          name=$1
112    
113          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
114                  echo "$name start"                  lxc_log "$name start"
115                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
116                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
117                  lxc-info  -n $name                  lxc-info  -n $name
# Line 116  while true; do Line 130  while true; do
130          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq 1 ]; then
131    
132                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
133                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
134    
135                  case $runlevel in                  case $runlevel in
136                  N*)                  N*)
137                          # nothing for new boot state                          # nothing for new boot state
138                  ;;                  ;;
139                  ??0)                  ??0)
140                          echo "$name halt"                          lxc_log "$name halt"
141                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
142                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
143                          break                          break
144                  ;;                  ;;
145                  ??6)                  ??6)
146                          echo "$name reboot";                          lxc_log "$name reboot";
147                          lxc-stop -n ${name}                          lxc-stop -n ${name}
148                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
149                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 141  while true; do Line 155  while true; do
155                  ;;                  ;;
156                  esac                  esac
157          else          else
158                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks"
159          fi          fi
160    
161          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
162          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
163  done  done
164    
165  echo "${name} exited"  lxc_log "$name watchdog exited"
166    
167  }  }
168    
169    
170    usage() {
171            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
172            exit 3
173    }
174    
175  command_on_lxc() {  command_on_lxc() {
176  command=$1  command=$1
177  shift  shift
# Line 164  case "$command" in Line 183  case "$command" in
183  start)  start)
184          lxc_exists $1          lxc_exists $1
185          cleanup_init_scripts $1          cleanup_init_scripts $1
186          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
187          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
188            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
189          lxc_start $1          lxc_start $1
190          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
191          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 180  reload|force-reload|restart|reboot) Line 200  reload|force-reload|restart|reboot)
200  watchdog)  watchdog)
201          lxc_watchdog $1          lxc_watchdog $1
202          ;;          ;;
203    boot)
204            echo $1 > /var/lib/lxc/$1/on_boot
205            ;;
206    disable)
207            echo -n > /var/lib/lxc/$1/on_boot
208            ;;
209  *)  *)
210          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
211          ;;          ;;
212    
213  esac  esac
# Line 190  esac Line 215  esac
215  }  }
216    
217  command=$1  command=$1
218  shift  test -z "$command" && usage
   
219  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
220    shift
221    
222  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
223          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
224                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
225                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
226                            command_on_lxc $command $name
227                    else
228                            echo "# skip $command $name"
229                    fi
230          done          done
231  else  else
232          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.186  
changed lines
  Added in v.218

  ViewVC Help
Powered by ViewVC 1.1.26